=== debian/changelog ===
mold (1.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Remove debian/patches/disable-large-ali.diff as it is
    fixed upstream

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 18 Jun 2022 09:35:23 +0200

mold (1.2.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 28 Apr 2022 22:31:44 +0200

mold (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release
    - Add dwarfdump as build dep

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 21 Apr 2022 09:43:55 +0200

mold (1.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 08 Mar 2022 12:14:43 +0100

mold (1.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 21 Feb 2022 08:42:18 +0100
