## mold 1.4.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION = 1.3.0
+VERSION = 1.4.0
 
 PREFIX = /usr/local
 BINDIR = $(PREFIX)/bin
@@ -10,6 +10,15 @@
 INSTALL_PROGRAM = $(INSTALL)
 INSTALL_DATA = $(INSTALL) -m 644
 
+OS := $(shell uname -s)
+ARCH := $(shell uname -m)
+
+ifeq ($(OS), Darwin)
+  TESTS := $(wildcard test/macho/*.sh)
+else
+  TESTS := $(wildcard test/elf/*.sh)
+endif
+
 D = $(DESTDIR)
 
 # CXX defaults to `g++`. Rewrite it with a vendor-neutral compiler
@@ -23,10 +32,7 @@
 STRIP = strip
 
 SRCS = $(wildcard *.cc elf/*.cc macho/*.cc)
-OBJS = $(SRCS:%.cc=out/%.o)
-
-OS := $(shell uname -s)
-ARCH := $(shell uname -m)
+OBJS = $(SRCS:%.cc=out/%.o) out/rust-demangle.o
 
 IS_ANDROID = 0
 ifneq ($(findstring -android,$(shell $(CC) -dumpmachine)),)
@@ -39,7 +45,7 @@
 CXXFLAGS = -O2
 
 MOLD_CXXFLAGS := -std=c++20 -fno-exceptions -fno-unwind-tables \
-                 -fno-asynchronous-unwind-tables -Ithird-party/xxhash \
+                 -fno-asynchronous-unwind-tables -Ithird-party \
                  -DMOLD_VERSION=\"$(VERSION)\" -DLIBDIR="\"$(LIBDIR)\""
 
 MOLD_LDFLAGS := -pthread -lz -lm -ldl
@@ -103,9 +109,9 @@
   MOLD_LDFLAGS += -lcrypto
 endif
 
-# '-latomic' flag is needed building on riscv64 system.
+# '-latomic' flag is needed building on armv6/riscv64 systems.
 # Seems like '-atomic' would be better but not working.
-ifeq ($(ARCH), riscv64)
+ifneq (,$(filter armv6% riscv64, $(ARCH)))
   MOLD_LDFLAGS += -latomic
 endif
 
@@ -132,6 +138,9 @@
 mold-wrapper.so: elf/mold-wrapper.c
 	$(CC) $(DEPFLAGS) $(CFLAGS) -fPIC -shared -o $@ $< $(MOLD_WRAPPER_LDFLAGS) $(LDFLAGS)
 
+out/rust-demangle.o: third-party/rust-demangle/rust-demangle.c
+	$(CC) $(CFLAGS) -c -o $@ $<
+
 out/%.o: %.cc out/elf/.keep out/macho/.keep
 	$(CXX) $(MOLD_CXXFLAGS) $(DEPFLAGS) $(CXXFLAGS) -c -o $@ $<
 
@@ -146,16 +155,17 @@
 
 $(TBB_LIB):
 	mkdir -p out/tbb
-	(cd out/tbb; cmake -G'Unix Makefiles' -DBUILD_SHARED_LIBS=OFF -DTBB_TEST=OFF -DCMAKE_CXX_FLAGS="$(CXXFLAGS) -D__TBB_DYNAMIC_LOAD_ENABLED=0" -DTBB_STRICT=OFF ../../third-party/tbb)
+	(cd out/tbb; cmake -G'Unix Makefiles' -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_SHARED_LIBS=OFF -DTBB_TEST=OFF -DCMAKE_CXX_FLAGS="$(CXXFLAGS) -D__TBB_DYNAMIC_LOAD_ENABLED=0" -DTBB_STRICT=OFF ../../third-party/tbb)
 	$(MAKE) -C out/tbb tbb
 	(cd out/tbb; ln -sf *_relwithdebinfo libs)
 
 test tests check: all
 ifeq ($(OS), Darwin)
-	$(MAKE) -C test -f Makefile.darwin --no-print-directory
-else
-	$(MAKE) -C test -f Makefile.linux --no-print-directory --output-sync
-endif
+	@$(MAKE) $(TESTS) --no-print-directory
+else
+	@$(MAKE) $(TESTS) --no-print-directory --output-sync
+endif
+
 	@if test -t 1; then \
 	  printf '\e[32mPassed all tests\e[0m\n'; \
 	else \
@@ -179,6 +189,20 @@
 	$(MAKE) test-arch TRIPLE=arm-linux-gnueabihf MACHINE=arm
 	$(MAKE) test-arch TRIPLE=riscv64-linux-gnu MACHINE=riscv64
 
+# macOS's GNU make hasn't been updated since 3.8.1 perhaps due a concern
+# of GPLv3. The --output-sync flag was introduced in GNU Make 4.0, so we
+# can't use that flag on macOS.
+#
+# `tail -r | tail -r` is a poor-man's way to enable full buffering on a
+# command output. `tail -r` outputs an input from the last line to the
+# first.
+$(TESTS):
+ifeq ($(OS), Darwin)
+	@set -o pipefail; ./$@ 2>&1 | tail -r | tail -r
+else
+	@./$@
+endif
+
 install: all
 	$(INSTALL) -d $D$(BINDIR)
 	$(INSTALL_PROGRAM) mold $D$(BINDIR)
@@ -216,4 +240,4 @@
 clean:
 	rm -rf *~ mold mold-wrapper.so out ld ld64 mold-*-linux.tar.gz
 
-.PHONY: all test tests check clean test-arch test-all test-asan test-ubsan test-tsan
+.PHONY: all test tests check clean test-arch test-all test-asan test-ubsan test-tsan $(TESTS)
