=== debian/changelog ===
mold (1.4.0+dfsg-1) unstable; urgency=medium

  [ Roger Shimizu ]
  * d/control:
    - Sort B-D list.
    - Remove libstdc++-10-dev and unused clang from B-D list.
    - Add libmimalloc-dev and libtbb-dev to B-D list.
  * debian/rules:
    - Prefer to use system library mimalloc and tbb.
  * debian/patches:
    - Add patch to avoid overwriting C*FLAGS set by debian/rules.

  [ Sylvestre Ledru ]
  * New upstream release
  * Add gdb as a build dep for tests
  * For now, use TBB from the tree
    See https://github.com/rui314/mold/issues/600

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 05 Aug 2022 09:43:13 +0200

mold (1.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 02 Jul 2022 11:25:04 +0200
